/*
 * ANALOG_V001.c
 *
 * Created: 21.09.2011 10:21:33
 *  Author: Schmitt
 */ 

#define F_CPU 8000000

#include <stdint.h>

#include <avr/io.h>				// Grundfunktionen
#include <util/delay.h>			// fr Pausenzeiten bentigt
#include <stdlib.h>				// fr LCDisplay
#include "lcd-routines.h"		// fr LCDisplay
#include "takter.h"


#include <avr/interrupt.h>
#include "dos.h"			
#include "fat.h"			
#include "dosdefs.h"						
#include "mmc_spi.h"
#include "dir.h"
#include "find_x.h"
#include "drivefree.h"

// AD Wandler Hauptfunktion
//////////////////////////////////////////////////////////////////////////////////

uint16_t readADC(uint8_t channel) {
	uint8_t i;
	uint16_t result = 0;
	
	// Den ADC aktivieren und Teilungsfaktor auf 64 stellen
	ADCSRA = (1<<ADEN) | (1<<ADPS2) | (1<<ADPS1);

	// Kanal des Multiplexers waehlen
	// Interne Referenzspannung verwenden (1/1 = 2,56 V / 0/0 = 5,0V)		Pin auswhlen
	ADMUX = channel															| (1<<MUX0) | (1<<MUX1) | (1<<MUX2);		//channel | (1<<REFS1) | (1<<REFS0)
	
	// Den ADC initialisieren und einen sog. Dummyreadout machen
	ADCSRA |= (1<<ADSC);
	while(ADCSRA & (1<<ADSC))
	{}
	
	// Jetzt 3x die analoge Spannung and Kanal channel auslesen
	// und dann Durchschnittswert ausrechnen.
	for(i=0; i<3; i++) {
		// Eine Wandlung
		ADCSRA |= (1<<ADSC);
		// Auf Ergebnis warten...
		while(ADCSRA & (1<<ADSC));
		
		result += ADCW;
	}
	
	// ADC wieder deaktivieren
	ADCSRA &= ~(1<<ADEN);
	
	result /= 3;
	
	return result;
}

// AD Wandler Ende
//////////////////////////////////////////////////////////////////////////////////

//SD-Karte
	
	uint8_t written;

int main(void)
{
	//DDRA = 0b00000000;			// LCD Konfiguriert durch lcd-routines / Analogeingang wird von das Einstellbytes (ADMUX) definiert
	DDRB = 0b11111111;				// Configuration
	DDRC = 0b11111111;				// test zur anzeige des analogwertes
	DDRD = 0b11110011;				// Taster und LEDs
	//DDRD = 0b11111111;			// test zur anzeige des analogwertes
	
	
	//LCD Zubehr
	lcd_init();						//LCD Initialisierung
	
	float variable;					//deklarieren Integer
    //char Buffer[16];				//Puffer fr die LCD Anzeige generieren
	char Buffer[20];
	
	//SD-Karte Ini
	
	MMC_IO_Init();
	
	uint8_t count1 = 0;
	
	//Temperaturanzeige
	
	int n = 0;				// Schleifenzhler
	int wert = 0;			// Verarbeitungsspeicher
	int temp1;				// Volle Zahl
	int temp2;				// Kommastelle
	float temp3;			// Voller Wert
	
	// Datum Zeitanzeige
	
	int weekday = 0;
	int day = 0;
	int month = 0;
	int year = 0;
	
	int sec = 0;
	int min = 0;
	int hr = 0;
	
	// Hauptprogramm
	
		//Schreiben RTC 
		////////// 01	Tag
        write();
		start();
		
		send1();
		send1();
		send0();
		send1();
		send0();
		send0();
		send0();
		send0();
		
		read();
		takter();
		write();
		
		send0();
		send0();
		send0();
		send0();
		send0();
		send1();
		send0();
		send0();
		
		read();
		takter();
		write();
		
		send0();
		send0();
		send0();
		send1();
		send0();
		send0();
		send1();
		send1(); 
		
		read();
		takter();
		write();
		stop();
		////////// 02	Monat
		start();
		
		send1();
		send1();
		send0();
		send1();
		send0();
		send0();
		send0();
		send0();
		
		read();
		takter();
		write();
		
		send0();
		send0();
		send0();
		send0();
		send0();
		send1();
		send0();
		send1(); 
		
		read();
		takter();
		write();
		
		send0();
		send0();
		send0();
		send1();
		send0();
		send0();
		send1();
		send0(); 
		
		read();
		takter();
		write();
		stop();
		////////// 03	Jahr
		start();
		
		send1();
		send1();
		send0();
		send1();
		send0();
		send0();
		send0();
		send0();
		
		read();
		takter();
		write();
		
		send0();
		send0();
		send0();
		send0();
		send0();
		send1();
		send1();
		send0(); 
		
		read();
		takter();
		write();
		
		send0();
		send0();
		send0();
		send1();
		send0();
		send0();
		send0();
		send1(); 
		
		read();
		takter();
		write();
		stop();
		////////// 04	Stunde
		start();
		
		send1();
		send1();
		send0();
		send1();
		send0();
		send0();
		send0();
		send0();
		
		read();
		takter();
		write();
		
		send0();
		send0();
		send0();
		send0();
		send0();
		send0();
		send1();
		send0(); 
		
		read();
		takter();
		write();
		
		send0();
		send0();
		send0();
		send1();
		send0();
		send0();
		send0();
		send0(); 
		
		read();
		takter();
		write();
		stop();
		////////// 05	Minute
		start();
		
		send1();
		send1();
		send0();
		send1();
		send0();
		send0();
		send0();
		send0();
		
		read();
		takter();
		write();
		
		send0();
		send0();
		send0();
		send0();
		send0();
		send0();
		send0();
		send1(); 
		
		read();
		takter();
		write();
		
		send0();
		send0();
		send0();
		send0();
		send1();
		send0();
		send0();
		send1(); 
		
		read();
		takter();
		write();
		stop();
		////////// 06	Sekunde
		start();
		
		send1();
		send1();
		send0();
		send1();
		send0();
		send0();
		send0();
		send0();
		
		read();
		takter();
		write();
		
		send0();
		send0();
		send0();
		send0();
		send0();
		send0();
		send0();
		send0(); 
		
		read();
		takter();
		write();
		
		send0();
		send0();
		send0();
		send0();
		send1();
		send0();
		send0();
		send0(); 
		
		read();
		takter();
		write();
		stop();
		////////// 07	Wochentag
		start();
		
		send1();
		send1();
		send0();
		send1();
		send0();
		send0();
		send0();
		send0();
		
		read();
		takter();
		write();
		
		send0();
		send0();
		send0();
		send0();
		send0();
		send0();
		send1();
		send1(); 
		
		read();
		takter();
		write();
		
		send0();
		send0();
		send0();
		send0();
		send0();
		send1();
		send1();
		send1(); 
		
		read();
		takter();
		write();
		stop();
	
	//SD-Karte
	
	uint8_t written;
	
	
		
	//Hauptprogrammschleife



	while(1)						
    {
        
		//////////////////////////////////////////////////////////////////////////		nur fr Tests
		while (1)										// Warten auf Startsignal                             
				{
				if(bit_is_set(PIND, 2))
				{break;}
				else
				{
				lcd_clear(); 
				lcd_setcursor(0,1);						// Gehe zu Pos. XY
				lcd_string("Start" );
				lcd_setcursor(0,2);						// Gehe zu Pos. XY
				lcd_string("Taster 1" );
				PORTD |= (1<<PD5);						// nur PIN 4 von byte B Ansteuern (ein)
				_delay_ms(100);
				PORTD &=~ (1<<PD5);						// nur PIN 4 von byte B Ansteuern (Aus)
				_delay_ms(100);}
				}
		//////////////////////////////////////////////////////////////////////////
		
		//Kontrollblinker
		
		PORTD |= (1<<PD5);						// nur PIN 4 von byte B Ansteuern (ein)
		_delay_ms(100);
		PORTD &=~ (1<<PD5);						// nur PIN 4 von byte B Ansteuern (Aus)
		_delay_ms(100);
		
		PORTD |= (1<<PD5);						// nur PIN 4 von byte B Ansteuern (ein)
		_delay_ms(100);
		PORTD &=~ (1<<PD5);						// nur PIN 4 von byte B Ansteuern (Aus)
		_delay_ms(100);
		
		PORTD |= (1<<PD5);						// nur PIN 4 von byte B Ansteuern (ein)
		_delay_ms(100);
		PORTD &=~ (1<<PD5);						// nur PIN 4 von byte B Ansteuern (Aus)
		_delay_ms(100);
		
		//Taster Befehler (LED an aus)
		
		if (bit_is_set(PIND, 2)) {PORTD |= (1<<PD0);}
		else{}
		
		if (bit_is_set(PIND, 3)) {PORTD |= (1<<PD1);}
		else{}
		
			
		if (bit_is_set(PIND, 4)) {PORTD &= ~(1<<PD0); PORTD &= ~(1<<PD1);}	
		else{}	
		
			
		//AD Wandler
		
		uint16_t result = readADC(0);	//Auslesen der analogen Spannungen an Pin 0,
										// also ADC0. In result steht das Ergebnis.
		
		// LCD-Ausgabe
		
		lcd_data( variable );			//Datenausgabe fr LCD einschalten
	
		variable = result;				//Schreiben des Messergebnisses in LCD Variable (bzw Buffer)
	
		itoa( variable, Buffer, 10 );	// Umwandeln des result Wertes und schreiben in den Buffer	/ 10 fr dezimal 2 fr binr
		
		lcd_clear();					// LCD Anzeige leeren
		
		lcd_string("AD-Wandler:");			//direkte Ausgabe des Klammerinhaltes
		lcd_setcursor(0,2);					//Zeilenwechsel auf Position 0 in zeile 2
		lcd_string( Buffer );									//Ausgabe des Buffer Inhaltes
		
		
		// Lesen RTC
		//////////////////////////////////////////////////////////////////////////
		
		
		//////////////////////////////////////////////////////////////////////////
		//Lesen
		
		//Tag
		start();
		write();
		
		send1();
		send1();
		send0();
		send1();
		send0();
		send0();
		send0();
		send0();
		
		read();
		takter();
		write();
		
		send0();
		send0();
		send0();
		send0();
		send0();
		send1();
		send0();
		send0();
		
		read();
		takter();
		write();
		restart();
		
		send1();
		send1();
		send0();
		send1();
		send0();
		send0();
		send0();
		send1();
		
		read();
		takter();
		
		day=0;
		for (n=0; n<8; n++)
          {
            PORTC |= (1<<PC0);
            _delay_ms(10);
            if (bit_is_set(PINC, 1)) {day |= (128>>n);}     
            _delay_ms(10);
            PORTC &=~ (1<<PC0);
          }
		
		write();
		send1();
		stop();
		
		//////////////////////////////////////////////////////////////////////////
		//Monat
		start();
		write();
		
		send1();
		send1();
		send0();
		send1();
		send0();
		send0();
		send0();
		send0();
		
		read();
		takter();
		write();
		
		send0();
		send0();
		send0();
		send0();
		send0();
		send1();
		send0();
		send1();
		
		read();
		takter();
		write();
		restart();
		
		send1();
		send1();
		send0();
		send1();
		send0();
		send0();
		send0();
		send1();
		
		read();
		takter();
		
		month=0;
		for (n=0; n<8; n++)
          {
            PORTC |= (1<<PC0);
            _delay_ms(10);
            if (bit_is_set(PINC, 1)) {month |= (128>>n);}     
            _delay_ms(10);
            PORTC &=~ (1<<PC0);
          }
		
		write();
		send1();
		stop();
		
		//////////////////////////////////////////////////////////////////////////
		//Jahr
		start();
		write();
		
		send1();
		send1();
		send0();
		send1();
		send0();
		send0();
		send0();
		send0();
		
		read();
		takter();
		write();
		
		send0();
		send0();
		send0();
		send0();
		send0();
		send1();
		send1();
		send0();
		
		read();
		takter();
		write();
		restart();
		
		send1();
		send1();
		send0();
		send1();
		send0();
		send0();
		send0();
		send1();
		
		read();
		takter();
		
		year=0;
		for (n=0; n<8; n++)
          {
            PORTC |= (1<<PC0);
            _delay_ms(10);
            if (bit_is_set(PINC, 1)) {year |= (128>>n);}     
            _delay_ms(10);
            PORTC &=~ (1<<PC0);
          }

		write();
		send1();
		stop();
		
		//////////////////////////////////////////////////////////////////////////
		//Stunde
		start();
		write();
		
		send1();
		send1();
		send0();
		send1();
		send0();
		send0();
		send0();
		send0();
		
		read();
		takter();
		write();
		
		send0();
		send0();
		send0();
		send0();
		send0();
		send0();
		send1();
		send0();
		
		read();
		takter();
		write();
		restart();
		
		send1();
		send1();
		send0();
		send1();
		send0();
		send0();
		send0();
		send1();
		
		read();
		takter();
		
		hr=0;
		for (n=0; n<8; n++)
          {
            PORTC |= (1<<PC0);
            _delay_ms(10);
            if (bit_is_set(PINC, 1)) {hr |= (128>>n);}     
            _delay_ms(10);
            PORTC &=~ (1<<PC0);
          }
		
		write();
		send1();
		stop();
		
		//////////////////////////////////////////////////////////////////////////
		//Minute
		start();
		write();
		
		send1();
		send1();
		send0();
		send1();
		send0();
		send0();
		send0();
		send0();
		
		read();
		takter();
		write();
		
		send0();
		send0();
		send0();
		send0();
		send0();
		send0();
		send0();
		send1();
		
		read();
		takter();
		write();
		restart();
		
		send1();
		send1();
		send0();
		send1();
		send0();
		send0();
		send0();
		send1();
		
		read();
		takter();
		
		min=0;
		for (n=0; n<8; n++)
          {
            PORTC |= (1<<PC0);
            _delay_ms(10);
            if (bit_is_set(PINC, 1)) {min |= (128>>n);}     
            _delay_ms(10);
            PORTC &=~ (1<<PC0);
          }
		
		write();
		send1();
		stop();
		
		//////////////////////////////////////////////////////////////////////////
		//Sekunde
		start();
		write();
		
		send1();
		send1();
		send0();
		send1();
		send0();
		send0();
		send0();
		send0();
		
		read();
		takter();
		write();
		
		send0();
		send0();
		send0();
		send0();
		send0();
		send0();
		send0();
		send0();
		
		read();
		takter();
		write();
		restart();
		
		send1();
		send1();
		send0();
		send1();
		send0();
		send0();
		send0();
		send1();
		
		read();
		takter();
		
		sec=0;
		for (n=0; n<8; n++)
          {
            PORTC |= (1<<PC0);
            _delay_ms(10);
            if (bit_is_set(PINC, 1)) {sec |= (128>>n);}     
            _delay_ms(10);
            PORTC &=~ (1<<PC0);
          }
		
		write();
		send1();
		stop();
		
		//////////////////////////////////////////////////////////////////////////
		//Wochentag
		start();
		write();
		
		send1();
		send1();
		send0();
		send1();
		send0();
		send0();
		send0();
		send0();
		
		read();
		takter();
		write();
		
		send0();
		send0();
		send0();
		send0();
		send0();
		send0();
		send1();
		send1();
		
		read();
		takter();
		write();
		restart();
		
		send1();
		send1();
		send0();
		send1();
		send0();
		send0();
		send0();
		send1();
		
		read();
		takter();
		
		weekday=0;
		for (n=0; n<8; n++)
          {
            PORTC |= (1<<PC0);
            _delay_ms(10);
            if (bit_is_set(PINC, 1)) {weekday |= (128>>n);}     
            _delay_ms(10);
            PORTC &=~ (1<<PC0);
          }
		
		write();
		send1();
		stop();
		
		// LCD-Ausgabe Tag / Monat
		
		lcd_data( variable );					//Datenausgabe fr LCD einschalten
		
		variable = day;						    //Schreiben des Messergebnisses in LCD Variable (bzw Buffer)
	
		itoa( variable, Buffer, 16 );		    //Umwandlung des float Variablenwertes in einen string
		
		lcd_clear();							// LCD Anzeige leeren
		
		lcd_string("Tag:");					    //direkte Ausgabe des Klammerinhaltes, automatischer Zeilenumbruch
		lcd_setcursor(0,2);					    //Zeilenwechsel auf Position 0 in zeile 2
		lcd_string( Buffer );					//Ausgabe des Buffer Inhaltes
		
		_delay_ms(2000);
		
		lcd_data( variable );					//Datenausgabe fr LCD einschalten
		
		variable = month;						//Schreiben des Messergebnisses in LCD Variable (bzw Buffer)
	
		itoa( variable, Buffer, 16 );		    //Umwandlung des float Variablenwertes in einen string
		
		lcd_clear();							// LCD Anzeige leeren
		
		lcd_string("Monat:");				    //direkte Ausgabe des Klammerinhaltes, automatischer Zeilenumbruch
		lcd_setcursor(0,2);					    //Zeilenwechsel auf Position 0 in zeile 2
		lcd_string( Buffer );					//Ausgabe des Buffer Inhaltes
		
		_delay_ms(2000);
		
		
		// Datumsanzeige
		
		lcd_clear();							// LCD Anzeige leeren
		
		lcd_data( variable );					//Datenausgabe fr LCD einschalten
		lcd_setcursor(0,1);
		lcd_string("Datum:");
		lcd_setcursor(0,2);
		
		variable = day;
		itoa( variable, Buffer, 16 );	    	//Umwandlung des float Variablenwertes in einen string
		
		lcd_string( Buffer );	
		lcd_string(".");
		
		variable = month;
		itoa( variable, Buffer, 16 );		    //Umwandlung des float Variablenwertes in einen string
		lcd_string( Buffer );					//Ausgabe des Buffer Inhaltes
		lcd_string(".20");
		
		variable = year;
		itoa( variable, Buffer, 16 );		    //Umwandlung des float Variablenwertes in einen string
		lcd_string( Buffer );	
		_delay_ms(2000);
		
		
		// Zeitrabzeige
		
		lcd_clear();							// LCD Anzeige leeren
		lcd_data( variable );					//Datenausgabe fr LCD einschalten
		lcd_setcursor(0,1);
		lcd_string("Zeit:");
		lcd_setcursor(0,2);
		
		variable = hr;
		itoa( variable, Buffer, 16 );		    //Umwandlung des float Variablenwertes in einen string
		lcd_string( Buffer );	
		lcd_string(":");
		
		variable = min;
		itoa( variable, Buffer, 16 );		    //Umwandlung des float Variablenwertes in einen string
		lcd_string( Buffer );					//Ausgabe des Buffer Inhaltes
		lcd_string(":");
		
		variable = sec;
		itoa( variable, Buffer, 16 );		    //Umwandlung des float Variablenwertes in einen string
		lcd_string( Buffer );	
		_delay_ms(2000);
		
		//////////////////////////////////////////////////////////////////////////
		// Temperatur Auslesen
		
		write();
		start();
		stop();
		start();
		
		send1();
		send0();
		send0();
		send1();
		send0();
		send0();
		send0();
		send0();
		
		read();
		takter();
		write();
		
		send1();
		send1();
		send1();
		send0();
		send1();
		send1();
		send1();
		send0();
		
		read();
		takter();
		write();
		
		stop();
		start();
		
		send1();
		send0();
		send0();
		send1();
		send0();
		send0();
		send0();
		send0();
		
		read();
		takter();
		write();
		
		send1();
		send0();
		send1();
		send0();
		send1();
		send0();
		send1();
		send0();
		
		read();
		takter();
		write();
		restart();					//WICHTIG
		
		send1();
		send0();
		send0();
		send1();
		send0();
		send0();
		send0();
		send1();
		
		read();
		takter();
		
		temp1=0;
		for (n=0; n<8; n++)
          {
            PORTC |= (1<<PC0);
            _delay_ms(10);
			//wert = PINC1;
            if (bit_is_set(PINC, 1)) {temp1 |= (128>>n);}     
            if (temp1 > 127) {temp1 = temp1 - 256;}
            _delay_ms(10);
            PORTC &=~ (1<<PC0);
          }
		
		write();
		send0();
		read();
		
		temp2=0;
		for (n=0; n<8; n++)
          {
            PORTC |= (1<<PC0);
            _delay_ms(10);
			//wert = PINC1;
            if (bit_is_set(PINC, 1)) {temp2 |= (128>>n);}     
            _delay_ms(10);
            PORTC &=~ (1<<PC0);
          }
		
		write();
		send1();
		stop();	

		// LCD-Ausgabe Temperatur
		
		lcd_data( variable );					//Datenausgabe fr LCD einschalten
		
		temp3 = 0;
		temp3 = temp1;
		
		if (temp2 != 0){temp3 = temp1 + 0.5;}
		
		variable = temp3;						//Schreiben des Messergebnisses in LCD Variable (bzw Buffer)
	
		dtostrf( variable, 1, 1, Buffer );		//Umwandlung des float Variablenwertes in einen string
		
		lcd_clear();							// LCD Anzeige leeren
		
		lcd_string("Temperatur:");				//direkte Ausgabe des Klammerinhaltes, automatischer Zeilenumbruch
		lcd_setcursor(0,2);						//Zeilenwechsel auf Position 0 in zeile 2
		
		lcd_string(Buffer);						//Ausgabe des Buffer Inhaltes
		lcd_string(" Grad C.");
		
		_delay_ms(2000);
		
		
		//SD-Karte
		
		while (1)								//Warten auf Taster 2                             
				{
				if(bit_is_set(PIND, 3))
				{break;}
				else
				{
				lcd_clear(); 
				lcd_setcursor(0,1);							// Gehe zu Pos. XY
				lcd_string("Taster 2" );
				lcd_setcursor(0,2);							// Gehe zu Pos. XY
				lcd_string("SD Beschreiben" );
				PORTD |= (1<<PD5);						    // nur PIN 4 von byte B Ansteuern (ein)
				_delay_ms(100);
				PORTD &=~ (1<<PD5);						    // nur PIN 4 von byte B Ansteuern (Aus)
				_delay_ms(100);}
				}
		
		GetDriveInformation();								// Scannen der SD Karte
		
		if(GetDriveInformation()!=F_OK)						// Fehlermeldung SD-Karte
		{
		lcd_clear(); 
		lcd_setcursor(0,1);									// Gehe zu Pos. XY
		lcd_string("Fehler SD-Karte " );					// Ausgabe Maske
  
		while(1) {_delay_ms(2000);break;}					// Errorschleife 
        }
		
		// /*
		if(Fopen("Test.htm",'a')==F_OK)					    // Erstellen der Date Test.htm
			{
				written=Fwrite("Hallo Welt.",11);			// HTML-script		(,19)	die Kommazahl muss genau der zeichenanzah entsprechen
				Fflush();
				Fclose();                                   // SD-Karte schlieen
				
				
				
				
				if(Fopen("log.htm",'a')==F_OK)					    // Erstellen der Date log.htm
				{
				written=Fwrite("<html><body><table>" ,19);			// HTML-script		(,19)	erstellen einer Tabelle
				Fflush();
				
					count1 = count1 + 1;
				
					written=Fwrite("<tr><td>" ,10);							// HTML-script
					Fflush();												// Speicher auf die SD-Karte schreiben		    
					itoa( count1, Buffer, 10 );								// Umwandlung                          
					written=Fwrite( Buffer ,5);								// Variable auf SD-Karte schreiben	
					Fflush();												// Speicher auf die SD-Karte schreiben
					written=Fwrite("</td>" ,5);								// HTML-script
					Fflush();												// Speicher auf die SD-Karte schreiben
				
				
				Fclose();                                          // SD-Karte schlieen
				lcd_clear();
				}		
			}		
		
    }
}